#include <iostream>
#include <vector>
#include <boost/smart_ptr.hpp>

template<typename T> struct ShallowCopy {
	static boost::shared_ptr<T> copy(boost::shared_ptr<T> t) {
		return boost::shared_ptr<T>(t);
	}
};


template<typename T> struct DeepCopy {
	static boost::shared_ptr<T> copy(boost::shared_ptr<T> t) {
		return boost::shared_ptr<T>(new T(*t) );
	}
};

template<typename T> struct CloneCopy {
	static boost::shared_ptr<T> copy(boost::shared_ptr<T> t) {
		return boost::shared_ptr<T>( t->clone() );
	}
};

template<typename T, template <typename> class Copy>
void function1(std::vector<boost::shared_ptr<T> > input) {
	typedef typename std::vector<boost::shared_ptr<T> > Vect;
	Vect working_copy;
	for(typename Vect::iterator it = input.begin(); it != input.end(); ++it )
		working_copy.push_back( Copy<T>::copy(*it) );
	//tutaj dalsza czesc algorytmu
};


int main() {

	std::vector<boost::shared_ptr<int> > v;
	function1<int, ShallowCopy>( v );

    return 0;

}
