#include <iostream>
#include <vector>
#include <list>
#include <deque>

//implementacja, do której dostarcza się typ kontenera
template<typename T, typename Contener = std::deque<T> > class Stack {
public:
    class EmptyStackException : public std::exception {};

    bool empty() const { return c.empty(); }

    T pop() {
        if( empty() ) throw EmptyStackException();
        T ret = c.back();
        c.pop_back();
        return ret;
    }
    void push(const T& t) { c.push_back(t); }
private:
    Contener c;
};

//implementacja, która tworzy typ kontenera wykorzystując typ T
template<typename T,
		 template <typename Element, typename Allocator> class Contener> class Stack2 {
public:
    class EmptyStackException : public std::exception {};

    bool empty() const { return c.empty(); }

    T pop() {
        if( empty() ) throw EmptyStackException();
        T ret = c.back();
        c.pop_back();
        return ret;
    }
    void push(const T& t) { c.push_back(t); }
private:
    Contener<T, std::allocator<T> > c;
};

int main() {
    {
		Stack<int, std::deque<int> > s;
		s.push(1);
		s.push(2);
		std::cout << s.pop() << std::endl;
    }

    {
		Stack2<int, std::list> s;
		s.push(1);
		s.push(2);
		std::cout << s.pop() << std::endl;
    }
    return 0;

}
